function [E,pyx] = computeE(vr,Yt,Chat,Br)
global M K K0 addCt
global obsmodel one_sensor_per_node squared_sensor
%squared_sensor, K0
[alpha1,alpha2,sigobs1,sigobs2,pf_type,pf_paramsa,pf_paramsb,aoutlier]=getobsmodel(obsmodel); %disp([alpha1, M])
Ct = Chat + Br*vr;
if addCt
    pyx = 1;
    for j = 1:M
        Y1 = Yt(2*j-1);     %sensor 1            
        hx = Ct(j,1);   % (j <= K) * Ct(j,1)^2 + (j > K) * Ct(j,1); %
        if squared_sensor, hx = (j<=K0)*(Ct(j,1)^2) + (j>K0)*Ct(j,1); end
        pyxj1 = ( alpha1(j)*pdf(pf_type,Y1-aoutlier*hx,pf_paramsa,pf_paramsb) + (1-alpha1(j))*gauss(0,sigobs1(j),( Y1- hx )') )';
        Y2 = Yt(2*j);          %sensor 2
        pyxj2 =( alpha2(j)*pdf(pf_type,Y2-aoutlier*hx,pf_paramsa,pf_paramsb) + (1-alpha2(j))*gauss(0,sigobs2(j),( Y2- hx )') )';
        pyxj = pyxj1.*pyxj2; %pyxj1; % ONE SENSOR PER NODE % pyxj at location j: product of sensor 1 & sensor 2 pdfs
        if one_sensor_per_node, pyxj = pyxj1; end
        pyx = pyx.*pyxj;        %computing pyx
    end %whenever the state and observation are far apart get a constant number = (alpha1(j)*unif(-10,10)*alpha2(j)*unif(-10,10))^M
else
    %     pyx = 1;
    %     for j = 1:M
    %         Y1 = Yt(2*j-1);     %sensor 1
    %         pyxj1 = ( alpha1(j)*pdf(pf_type,Y1,pf_paramsa,pf_paramsb) + (1-alpha1(j))*gauss(0,sigobs1(j),( Y1-Ct(j,1) )') )';
    %         Y2 = Yt(2*j);          %sensor 2
    %         pyxj2 =( alpha2(j)*pdf(pf_type,Y2,pf_paramsa,pf_paramsb) + (1-alpha2(j))*gauss(0,sigobs2(j),( Y2-Ct(j,1) )') )';
    %         pyxj = pyxj1.*pyxj2; %pyxj1;    % pyxj at location j: product of sensor 1 & sensor 2 pdfs
    %         pyx = pyx.*pyxj;        %computing pyx
    %     end %whenever the state and observation are far apart get a constant number = (alpha1(j)*unif(-10,10)*alpha2(j)*unif(-10,10))^M
end
%pyx = pyx;%.^(1/M); %cheating step: resample properly
if (pyx==0)
    %E = inf;
    E = -log(eps(0));
else
    E = -log(pyx);
end
%disp(E)
