%randn('state',100), rand('state',100)
global M K N T K0
global addCt biased_simulation Amult one_sensor_per_node squared_sensor
global obsmodel sysmodel 
global sqrtSigs sqrtSigr sqrtsigobs1 sqrtsigobs2 one
global pftype %'g' (pf=gordon) 'e' (pfeis) 'm' (pfmt)
global sigprod

sigprod = 1;
biasedsimulation = 0;
addCt = 1;
N = 1; T = Tset; %Npf = 30; %N used for PF

%obs model
one_sensor_per_node = 0;
squared_sensor = 0;
sigobs1 = 1 * ones(M,1); sigobs2 = 1 * ones(M,1);
sigobs1(1:K0,1) = 1;  sigobs2(1:K0,1) = 1;  %sigobs1, sigobs2: vectors
aoutlier = 0.2                     %aoutlier = 0 is same as setting addCt = 0 %0.2; %
pf_type = 'normal'; pf_paramsa = 0; pf_paramsb = 10*sqrt( sigobs1(1) ); %need to specify SIGMA NOT SIGMA^2 %900;% 3sigma = 90
alpha1 =  0.1*ones(M,1); alpha2 = 0.1*ones(M,1); %0.1*ones(M,1);
alpha1(1:K0,1) = 0.2; alpha2(1:K0,1) = 0.2; %0.1 ; %0.1; %0.01
t_is = [2:T];  alpha1_is = alpha1; alpha1_is(1) = 0.95;
obsmodel = struct('aoutlier',aoutlier,'alpha1',alpha1,'alpha2',alpha2,'sigobs1',sigobs1,'sigobs2',sigobs2,'pf_type',pf_type,'pf_paramsa',pf_paramsa,'pf_paramsb',pf_paramsb);
%pf_type = 'unif'; pf_paramsa = -10; pf_paramsb = 10; %pf_type = 'unif'; pf_paramsa = -100; pf_paramsb = 100;

%sys model 
Amult = 1 %use 0.7 when Yt(1) = Ct(1)^2 + wt  is obs model
Deltavec = [10*ones(1,K0), 5*ones(1,K2-K0), 1*ones(1,M-K2)]
Deltafull = diag(Deltavec);
U0 = eye(M,M); epsl = 0.2; %0.1; %0.01 %0.1;
z = epsl*ones(M,1); z(1) = 1- epsl/2; z = z/norm(z);
Bfull = orthcomplete(U0,z)
B = Bfull;
A = Amult*eye(M,M);
Sig = Deltafull;
Sig0 = Sig*0;
Ct0 = 0
%sysmodel = struct('Bs',Bs,'Br',Br,'Sigs',Sigs,'Sigr',Sigr,'As',As,'Ar',Ar);
 
%save time variables
sqrtSig = sqrtm(Sig);
sqrtsigobs1 = sqrt(sigobs1);sqrtsigobs2 = sqrt(sigobs2);
one = ones(N,1);

%disp('unknown initial state')
%initialize state at t=1  (known initial state)
t=1;
Ct = Ct0*ones(M,N); vt = zeros(M,N);%  + sqrtm(Sig0)*randn(M,N); 
wtilde = ones(1,N); wt = wtilde/N;wtilde_nr = inf(1,N);
state_true(t) = setstate(Ct,vt,wtilde,wt,wtilde_nr);
for t = 2:T
    [Ctold,vtold,wtilde,wt] = getstate(state_true(t-1));
    vt = A*vtold + sqrtSig*randn(M,N);    
    Ct = Ctold + B*vt;
    state_true(t) = setstate(Ct,vt,wtilde,wt,wtilde_nr);
%generate Yt from Ct
    if addCt
        for j = 1:M            
            hx = Ct(j,1); % (j <= K0) * Ct(j,1)^2 + (j > K0) * Ct(j,1);  %
            if squared_sensor, hx = (j<=K0)*(Ct(j,1)^2) + (j>K0)*Ct(j,1); end
            coin = rand;
            if   ( coin < alpha1(j) ) | ( ( coin< alpha1_is(j) )&ismember(t,t_is) ) % ( ( coin< alpha1_is(j) )&ismember(t,t_is) )
                %( (j<=K0)&(coin < 0.99) ) |  %  Y1 = Ct(j)/2 %+ random(pf_type,pf_paramsa,pf_paramsb) %+ 10              
                Y1 = aoutlier*hx + random(pf_type,pf_paramsa,pf_paramsb);
            else
                Y1 = hx + sqrtsigobs1(j)*randn(1,1);
            end
            coin = rand;
            if (coin < alpha2(j))
                Y2 = aoutlier*hx + random(pf_type,pf_paramsa,pf_paramsb);
            else
                Y2 = hx + sqrtsigobs2(j)*randn(1,1);
            end
  if one_sensor_per_node, Y2 = Y1; end
            Yt(2*j-1,t) = Y1; Yt(2*j,t) = Y2;
            clear Y1, clear Y2
        end
    else %no addCt
        %         for j = 1:M
        %             coin = rand;
        %             if ( (j<=K0)&(t<=7) )
        %                 %yobs = Ct(j) + sqrtsigobs1(j)*randn(1,1);
        %                 if (coin < 0.99)
        %                 %    Y1 = Ct(j)/2  %random(pf_type,pf_paramsa,pf_paramsb);
        %                         Y1 = random(pf_type,pf_paramsa,pf_paramsb);
        %                 else
        %                     Y1 = Ct(j) + sqrtsigobs1(j)*randn(1,1);
        %                 end
        %             else % j>K0 | t > 7
        %                 if (coin < alpha1(j))
        %                     Y1 =  random(pf_type,pf_paramsa,pf_paramsb);
        %                 else
        %                     Y1 = Ct(j) + sqrtsigobs1(j)*randn(1,1);
        %                 end
        %             end
        %             coin = rand;
        %             if  (coin < alpha2(j)) %( (j<=K0)&(coin < 0) ) %
        %                 Y2 =  random(pf_type,pf_paramsa,pf_paramsb);
        %             else
        %                 Y2 = Ct(j) + sqrtsigobs2(j)*randn(1,1);
        %             end
        %             Yt(2*j-1,t) = Y1; Yt(2*j,t) = Y2;
        %             clear Y1, clear Y2
        %         end
    end
end
disp('pf = adding large var noise to Ct, not to 0')
clear vts vtr vtsold vtrold vt vtold Ct Ctold Chat wtilde wt 
