% Code written by Namrata Vaswani
% This is the main file
%Code based on 
    %N. Vaswani, Particle Filtering for Large Dimensional State Spaces with Multimodal Observation Likelihoods, To Appear in IEEE Trans. Signal Processing

% Read README to understand the entire code

%sim=0;
choice = 1;
disp('some SigIS values are negative definite: result in imag sqrtm(SigIS)')
disp('fix resampling error: probably getting NaN')
K0 = 1; K2 = 2;  M = 3 %10
Nchoice = [50,100]  %[40]; %[50,100]; was with Deltavec=[25 5 5 5 5];0.1,0.5, 5,5
pfchoice = ['d','e','g','m','c','s'] ; %,
%[45] was with  Deltavec=[25 2 2 2 2];0.1,0.5, 5,5
%[40] was with  Deltavec=[10 2 2 2 2];0.1,0.5, 5,5
%Kchoice = [0,K0,M];
totiter = 100;
prefix = 'fig3b_'; %'c_fig3f_M10_' %'c_fig3f_M10_' % 'temp_' %'fig3c_'; % c_fig3f_ with M=5

global pftype,

randn('state',0), rand('state',0)
if sim
    for iter = [1:totiter]
        disp('need to change pfmt part in impsample')
        gendata2
        for Npf = Nchoice
            ct=1;
            for pftype = pfchoice %,'c'] %,'m','g']     %['e','m','g','s','d']  %'d':PF-Doucet, 'c': PF-EIS-MT
                pfeis
                save(['tmp_c_fig3f_M10_',pftype,'_M',num2str(M),'_N',num2str(Npf),'_iter',num2str(iter)])
                ct=ct+1;
            end
        end
        disp(iter)
    end
    %disp('using gditers 5')
else %sim=0, just load data from a mat file and plot
    clear rmse rmsedat
%    col = ['k-^';'r-*';'m-o';'g-x']  ;   %col = ['g-x';'b-s';'k-^';'m-o';'r-*'];
    totiterv = 90
 set(0,'defaultaxesfontsize',13)  
    for Npf =  Nchoice %40
        ct2=1;        
        for pftype = pfchoice %['e','d','g'] %,'c'] %['s','m','e','g','d']  %['e','d','m','g','s']
            for iter = [1:totiterv] 
                load([prefix,pftype,'_M',num2str(M),'_N',num2str(Npf),'_iter',num2str(iter)])                
                pfchoice = ['d','e','g'];%,'m','c'] ; %,
                col = ['r-*';'k-^';'m-o';'b-s';'b-+';'m-x']; %col = ['g-x';'b-s';'k-^';'m-o';'r-*'];
                [Ctmattrue,vtmattrue,wtildemat,wtmat,Cttrue,vttrue] = struct2mat(state_true);
                % [Ctmattrue,vtmattrue,wtildemat,wtmat,Cttrue,vttrue] = struct2mat(state_true,'b-o');
                %for p = 1:M
                %  figure(p)
                %  plot(Yt(2*p-1,:),'b-v'), hold on, plot(Yt(2*p,:),'b->'), %hold off
                % end
                % [Ctmat,vtmat,wtildemat,wtmat,Cthat,vthat,Neff] = struct2mat(state,col(ct2,:));
                [Ctmat,vtmat,wtildemat,wtmat,Cthat,vthat,Neff,logpy] = struct2mat(state);
                rmsedat(1:T,ct2,iter) = ( sum( (Cttrue-Cthat).^2,1) );
                Neffdat(1:T,ct2,iter) = Neff;
                logpydat(1:T,ct2,iter) = logpy;                
            end
            avgNeff(1:T,ct2,Npf) = mean( Neffdat(:,ct2,:), 3 ); 
            avglogpy(1:T,ct2,Npf) = (  mean( logpydat(:,ct2,:), 3 ) );            
            
            figure(Npf+5), plot(avgNeff(:,ct2,Npf),col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on 
            %legend('PF-MT','PF-EIS-MT','PF-Doucet','PF-EIS','PF-Original')
            title(['Effective particle size. Tracking with N = ',num2str(Npf),' particles'])
            grid minor
            %figure(Npf+4), plot(avglogpy(:,ct2,Npf),col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on 
            
            rmse(1:T,ct2,Npf) = sqrt( mean(rmsedat(:,ct2,:),3) ); %sqrt
            figure(Npf), plot(rmse(:,ct2,Npf),col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on,
            [perc,numlarge(1:T,ct2,Npf)] = get_large(rmsedat(:,ct2,:),sum(sqrt(sigobs1))*2,3);
            figure(Npf-1), plot(numlarge(:,ct2,Npf)*100/totiterv,col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on,
            
            [perc,numlarge(1:T,ct2,Npf)] = get_large(rmsedat(:,ct2,:),sum(sqrt(sigobs1))*10,3);
            figure(Npf-2), plot(numlarge(:,ct2,Npf)*100/totiterv,col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on,
                        
            ct2=ct2+1;
        end
        figure(Npf),
        xlabel('time, t'), ylabel('RMSE from ground truth')
        %legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
        legend('PF-Doucet','PF-EIS','PF-Original','PF-MT','PF-EIS-MT')
        title(['RMSE from ground truth. N = ',num2str(Npf),' particles'])
        grid minor
        figure(Npf-1),            
        xlabel('time, t'), ylabel('Percentage of times error > threshold'), 
        title(['Out of track %. N = ',num2str(Npf),' particles']) 
        %legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
        grid minor
        figure(Npf-2),                    
        xlabel('time, t'), ylabel('Percentage of times error > threshold'), 
        title(['Out of track %. N = ',num2str(Npf),' particles']) 
        %legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
        grid minor
%         figure(Npf+5),
%         xlabel('time, t'), ylabel('Avg Effective particle size, N_{eff}'), legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
%         grid minor
%         title(['Avg N_{eff}. Tracking with N = ',num2str(Npf),' particles'])
%         figure(Npf+4),
%         xlabel('time, t'), ylabel('Average LL'), legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
%         grid minor     
%         title(['Average LL. Tracking with N = ',num2str(Npf),' particles'])
         rmsedatNchoice{Npf} = rmsedat;
       % title(['Npf = ',num2str(Npf),' red, black, majenta, green'])
        %pause, figure(Npf), hold off
    end
     for Npf = Nchoice
        bndrmse = sqrt( get_percentbound(rmsedatNchoice{Npf},0.9999,3) );
        ct2=1;
        for pftype =  pfchoice %['s','m','e','g','d'] %['e','d','m','g','s']
            figure(Npf+1), plot(bndrmse(:,ct2),col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on,
            ct2 = ct2 + 1;
        end
        legend('PF-Doucet','PF-EIS','PF-Original','PF-MT','PF-EIS-MT')%legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
        xlabel('time, t'), ylabel('Worst Case RMSE from ground truth')
        title(['Worst case Error from ground truth. Tracking with N = ',num2str(Npf),' particles'])
        grid minor
     end
    for Npf = Nchoice
        bndrmse = sqrt( get_percentbound(rmsedatNchoice{Npf},0.5,3) );
        ct2=1;
        for pftype = pfchoice   %['s','m','e','g','d'] %['e','d','m','g','s']
            figure(Npf+2), plot(bndrmse(:,ct2),col(ct2,:),'LineWidth',2,'MarkerSize',12), hold on,
            ct2 = ct2 + 1;
        end
        %legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')%legend('PF-K dim','PF-MT','PF-EIS','PF-Original','PF-Doucet')
        xlabel('time, t'), ylabel('Median error from ground truth')
        title(['Median Error from ground truth. Tracking with N = ',num2str(Npf),' particles'])
        grid minor
    end
end
disp('copy changes in impsample for pfeis to pfmt')
%         figure(2*M+1),
%         xlabel('time, t'), ylabel('RMSE from ground truth')
%         legend('PF-K dim','PF-MT','PF-EIS','PF-Original')
%         title(['RMSE from ground truth. Tracking with N = ',num2str(Npf),' particles'])
%         grid on

ct = 1;
for Npf = Nchoice %[50 100 200] %
    for fno = [Npf-2, Npf-1,Npf, Npf+5]
        figure(fno)
        %legend('PF-Doucet (K=0)', 'PF-EIS (K=1)', 'PF-Original (K=3)')
        legend('PF-Doucet','PF-EIS','PF-Original','PF-MT','PF-EIS-MT')
        if (fno < Npf)
            title(['Out of track %. N = ',num2str(Npf),' particles']) 
        end
        saveas(fno,[prefix,'figr_',num2str(fno)],'fig')
    end
end

